--The Ecstacy Sound System V0.3 for Euphoria V2.1+
--Copyright (c) 1999, Liquid-Nitrogen Software.
--<June 22nd 1999>
-------------------------------------------------
--Web Site : http://members.xoom.com/nitrogen2000
--E-Mail   : nitrogen_069@hotmail.com
-------------------------------------------------
--
--DISCLAIMER :
--------------
--You may freely distribute this library package, aslong as it is un-modified,
--and at no cost. Liquid-Nitrogen Software may not be held responsable for any
--damages that occur as a result of the use or misuse of this library package.
--
--LISENCE:
----------
--You may use this library package free of charge in any FREEWARE programs.
--If you use this library package in a SHAREWARE program, you must provide
-- Liquid-Nitrogen Software with a free registered full copy of the program.
--If you use this library package in a COMMERCIAL program, you must first
-- contact Liquid-Nitrogen Software and obtain approval to use the library
-- package in your program.
--
--Failure to follow the rules of this lisence will be considered to be an
-- infringement on the copyright of this library package.
--
--Read "Readme.txt" and "Ecstacy.txt" for more information.
--

include machine.e
include file.e

global constant ECSTACY_VERSION = 0.3
global integer ECSTACY_DEBUG
sequence DEBUG_NAME
integer log_first, setup_error
log_first = 1
setup_error = 0

ECSTACY_DEBUG = 0
DEBUG_NAME = "debug.txt"

function allocate_proc(sequence code)
    atom proc
    proc = allocate(length(code))
    if proc then
	lock_memory(proc, length(code))
	poke(proc, code)
	return proc
    end if
    printf(1, "Unable to allocate memory for length-%d sequence...\nProgram aborted.\n", {length(code)})
    abort(1)
end function

----------------------------------------------------------------------------
--DOS WRAP------------------------------------------------------------------
----------------------------------------------------------------------------

atom DwBUFFERSIZE 
atom Dwlowbuffer

DwBUFFERSIZE = 8192
Dwlowbuffer = allocate_low(DwBUFFERSIZE)
if not Dwlowbuffer then
    puts(1,"Could Not Allocate buffer for Doswrap.\n\n")
    abort(1)
end if

integer Dwdos_error
Dwdos_error = 0
 
constant DwFAILED = -1
 
atom DwDosVersion, DwPlainDos
 
function DwGetDosVersion()
sequence regs
    regs = repeat(0,10)
    regs[REG_AX] = #3000
    regs = dos_interrupt(#21,regs)
    return remainder(regs[REG_AX],256) + floor(regs[REG_AX]/256)/100
end function
 
DwDosVersion = DwGetDosVersion()
DwPlainDos = atom(getenv("windir"))
 
function Dwdos_open(sequence FileName, integer Mode)
atom NameBuffer
sequence regs
Dwdos_error = 0
regs = repeat(0,10)
NameBuffer = allocate_low(length(FileName)+1)
if not NameBuffer then
    Dwdos_error = DwFAILED
    return DwFAILED
end if
poke(NameBuffer,FileName & 0)
if DwDosVersion < 7 or DwPlainDos then
    regs[REG_AX] = #3D00+Mode
    regs[REG_DS] = floor(NameBuffer/16)
    regs[REG_DX] = remainder(NameBuffer,16)
else
    regs[REG_AX] = #716C
    regs[REG_BX] = Mode
    regs[REG_CX] = 0
    regs[REG_DX] = #01
    regs[REG_DS] = floor(NameBuffer/16)
    regs[REG_SI] = remainder(NameBuffer,16)
    regs[REG_DI] = 1
end if
regs = dos_interrupt(#21,regs)
free_low(NameBuffer)
if and_bits(regs[REG_FLAGS],1) then
    Dwdos_error = regs[REG_AX]
    return DwFAILED
end if
return regs[REG_AX]
end function
 
function Dwdos_close(integer Handle)
sequence regs
    Dwdos_error = 0
    regs = repeat(0,10)
    regs[REG_AX] = #3E00
    regs[REG_BX] = Handle
    regs = dos_interrupt(#21,regs)
    if and_bits(regs[REG_FLAGS],1) then
	Dwdos_error = regs[REG_AX]
	return 0
    end if
    return 1
end function
 
function Dwblock_read(integer Handle, atom buffer, atom NbBytes)
sequence regs, outregs
atom bytes_written
bytes_written = 0
regs = repeat(0,10)
regs[REG_AX] = #3F00
regs[REG_BX] = Handle
regs[REG_DS] = floor(Dwlowbuffer/16)
regs[REG_DX] = remainder(Dwlowbuffer,16)
while NbBytes do
    if NbBytes > DwBUFFERSIZE then
    regs[REG_CX] = DwBUFFERSIZE
    else
	regs[REG_CX] = NbBytes
    end if
    NbBytes = NbBytes - regs[REG_CX]
    outregs = dos_interrupt(#21,regs)
    if and_bits(outregs[REG_FLAGS],1) then
	return -1
    end if
    mem_copy(buffer, Dwlowbuffer, regs[REG_CX])
    buffer = buffer + regs[REG_CX]
    bytes_written += outregs[REG_AX]
end while
return bytes_written
end function

function Dwblock_write(integer Handle, atom buffer, atom NbBytes)
sequence regs, outregs
atom bytes_written
bytes_written = 0
Dwdos_error = 0
regs = repeat(0,10)
regs[REG_AX] = #4000
regs[REG_BX] = Handle
regs[REG_CX] = NbBytes
regs[REG_DS] = floor(Dwlowbuffer/16)
regs[REG_DX] = remainder(Dwlowbuffer,16)
while NbBytes do
    if NbBytes > DwBUFFERSIZE then
	regs[REG_CX] = DwBUFFERSIZE
    else
	regs[REG_CX] = NbBytes
    end if
    mem_copy(Dwlowbuffer, buffer, regs[REG_CX])
    outregs = dos_interrupt(#21,regs)
    if and_bits(outregs[REG_FLAGS],1) then
	return -1
    end if
    buffer = buffer + regs[REG_CX]
    bytes_written += outregs[REG_AX]
    NbBytes = NbBytes - regs[REG_CX]
end while
return regs[REG_AX]
end function
 
function Dwdos_seek(integer Handle, integer Distance, integer Origin)
sequence regs
Dwdos_error = 0
regs = repeat(0,10)
regs[REG_AX] = #4200+Origin
regs[REG_BX] = Handle
regs[REG_CX] = floor(Distance / #10000)
regs[REG_DX] = remainder(Distance, #10000)
regs = dos_interrupt(#21,regs)
if and_bits(regs[REG_FLAGS],1) then
    Dwdos_error = regs[REG_AX]
    return -1
end if
return regs[REG_AX] + #10000 * regs[REG_DX]
end function

----------------------------------------------------------------------------
--PORT I/O------------------------------------------------------------------
----------------------------------------------------------------------------

constant in_byte_result = allocate_proc({0})
constant in_byte_proc = allocate_proc({#50,#52,#BA,#00,#00,#00,#00,#EC,#A2} & int_to_bytes(in_byte_result) & {#5A,#58,#C3})
constant out_byte_proc = allocate_proc({#50,#52,#BA,#00,#00,#00,#00,#B0,#00,#EE,#5A,#58,#C3})
constant out_word_proc = allocate_proc({#50,#52,#BA,#00,#00,#00,#00,#B8,#00,#00,#00,#00,#66,#EF,#5A,#58,#C3})

function Ein_byte(integer port)
    poke4(in_byte_proc + 3, port)
    call(in_byte_proc)
    return peek(in_byte_result)
end function

procedure Eout_byte(integer port, object data)
    poke4(out_byte_proc + 3, port)
    if atom(data) then
	data = {data}
    end if
    for i = 1 to length(data) do
	poke(out_byte_proc + 8, data[i])
	call(out_byte_proc)
    end for
end procedure

procedure Eout_word(integer port, object data)
    poke4(out_word_proc + 3, port)
    if atom(data) then
	data = {data}
    end if
    for i = 1 to length(data) do
	poke4(out_word_proc + 8, data[i])
	call(out_word_proc)
    end for
end procedure

function Ein_word(integer port)
    return Ein_byte(port) + (Ein_byte(port) * 256)
end function

constant IRQPS = 20
atom BUFFER_LEN

global atom DMA_BUFFER, DMA_LEN, CHANNELS, RATE
atom BASE_IO, DMA, IRQ, global_volume
integer IRQ_SAMPLES
BASE_IO = #220
IRQ = 5
DMA = 1
DMA_BUFFER = 0
DMA_LEN = 0
CHANNELS = 0
RATE = 11025
IRQ_SAMPLES = 0

procedure enable_irq(integer IrqNumber)
    if IrqNumber < 8 then 
	Eout_byte(#21,and_bits(Ein_byte(#21),not_bits(power(2,IrqNumber))))
    else       
	Eout_byte(#A1,and_bits(Ein_byte(#A1),not_bits(power(2,IrqNumber-8))))
    end if
end procedure

procedure disable_irq(integer IrqNumber)
    if IrqNumber < 8 then 
	Eout_byte(#21,or_bits(Ein_byte(#21),power(2,IrqNumber)))
    else       
	Eout_byte(#A1,or_bits(Ein_byte(#A1),power(2,IrqNumber-8)))
    end if
end procedure

global integer SOUND_INIT
global procedure set_global_volume(integer v)
    if SOUND_INIT = 0 then
	return
    end if
    if v < 0 then
	v = 0
    elsif v > 255 then
	v = 255
    end if
    poke(global_volume,v)
end procedure

global function get_global_volume()
    if SOUND_INIT = 0 then
	return 0
    end if
    return peek(global_volume)
end function

global procedure debug(sequence string)
integer LOG
if ECSTACY_DEBUG then
    if log_first = 1 then
	LOG = open(DEBUG_NAME, "w")
	log_first = 0
    else
	LOG = open(DEBUG_NAME, "a")
    end if
    puts(LOG, string)
    puts(LOG, 10)
    close(LOG)
end if
end procedure

procedure delay(atom sec)
atom clocks, elapsed, last, next, ncopy
    clocks = sec * 2386360
    Eout_byte(#43, 0)
    last = Ein_word(#40)
    elapsed = 0
    while elapsed < clocks do
	Eout_byte(#43, 0)
	next = Ein_word(#40)
	ncopy = next
	next = last - next
	if next < 0 then
	    next +=  65536
	end if
	elapsed += next
	last = ncopy
    end while
end procedure

function reset_dsp()
atom start
    debug("Resetting DSP... ")
    Eout_byte(BASE_IO + #6, 1)
    delay(.05)
    Eout_byte(BASE_IO + #6, 0)
    delay(.05)

    start = time()
    while 1 do
	if and_bits(Ein_byte(BASE_IO + #E),#80) then
	    if Ein_byte(BASE_IO + #A) = #AA then
		debug("DSP Reset Ok.")
		return 1
	    end if
	end if
	if time() - start > .2 then
	    debug("Could Not Reset DSP.")
	    return 0
	end if
    end while
end function

procedure write_dsp(integer value)
atom start
    debug("Writing DSP... ")
    start = time()
    while 1 do
	if and_bits(Ein_byte(BASE_IO + #C),#80) = 0 then
	    Eout_byte(BASE_IO + #C, value)
	    debug("DSP Write Ok.")
	    return
	end if
	if time() - start > .5 then
	    debug("Could Not Write DSP.")
	    setup_error = 1
	    return
	end if
    end while
end procedure

function read_dsp()
atom start
    debug("Reading DSP... ")
    start = time()
    while 1 do
	if and_bits(Ein_byte(BASE_IO + #E),#80) then
	    debug("DSP Read Ok.")
	    return Ein_byte(BASE_IO + #A)
	end if
	if time() - start > .5 then
	    debug("Could Not Read DSP.")
	    setup_error = 1
	    return -1
	end if
    end while
end function

function get_dsp_version()
    debug("Getting DSP Version.")
    write_dsp(#E1)
    return read_dsp() + (read_dsp()/100)
end function

function buffer_in_page(atom adr, integer len)
integer spage,epage
    debug("Checking Buffer Does Not Cross A Memory Page : ")
    spage = floor(adr / 65536)
    epage = floor((adr + len) / 65536)
    if epage = spage then
	debug("Buffer Ok.")
	return 1
    else
	debug("Buffer Not Ok.")
	return 0
    end if
end function

function allocate_dma_buffer(integer len)
atom adr
sequence adrs
adrs = {}
    debug("Allocating DMA Buffer.")
    while 1 do
	adr = allocate_low(len)
	if adr = 0 then
	   for i = 1 to length(adrs) do
	       free_low(adrs[i])
	   end for
	   debug("A Good DMA Buffer Was Not Found.")
	   return 0
	elsif buffer_in_page(adr,len) then
	   for i = 1 to length(adrs) do
	       free_low(adrs[i])
	   end for
	   debug("Found A Good DMA Buffer.")
	   return adr
	else
	   debug("Trying Another Buffer.")
	   adrs &= adr
	end if
    end while
    return adr
end function

sequence usual_address
atom code_segment, data_segment
atom save_segment, segment

atom ISR_ADR

ISR_ADR = allocate(312)
if ISR_ADR = 0 then
    puts(1,"Couldn't allocate ISR.")
    abort(1)
end if
lock_memory(ISR_ADR, 312)
poke(ISR_ADR, {
#9C,#60,#1E,#06,#68,#00,#00,#00,#00,#1F,#1E,#07,#BA,#00,#00,#00,#00,#83,#C2,#0E,
#EC,#31,#C0,#B0,#20,#89,#C2,#EE,#B4,#00,#80,#FC,#01,#75,#06,#BA,#A0,#00,#00,#00,
#EE,#B9,#00,#00,#00,#00,#BF,#00,#00,#00,#00,#39,#3D,#F4,#22,#84,#83,#75,#02,#01,
#CF,#89,#3D,#F4,#22,#84,#83,#BF,#00,#00,#00,#00,#B8,#7F,#00,#00,#F0,#F3,#AB,#B9,
#00,#00,#00,#00,#BA,#00,#00,#00,#00,#83,#3A,#00,#0F,#84,#99,#00,#00,#00,#BF,#00,
#00,#00,#00,#8B,#72,#08,#8B,#5A,#0C,#8B,#42,#10,#A3,#A1,#22,#84,#83,#8B,#42,#14,
#A3,#A7,#22,#84,#83,#8A,#42,#18,#F6,#25,#00,#00,#00,#00,#25,#00,#FF,#00,#00,#05,
#00,#00,#00,#00,#A3,#91,#22,#84,#83,#8B,#42,#04,#03,#02,#A3,#BC,#22,#84,#83,#51,
#B9,#00,#00,#00,#00,#EB,#00,#31,#C0,#8A,#06,#8A,#80,#00,#00,#00,#00,#2D,#80,#00,
#00,#00,#01,#07,#83,#C7,#04,#81,#C6,#00,#00,#00,#00,#81,#C3,#00,#00,#00,#00,#81,
#FB,#FF,#FF,#00,#00,#7E,#07,#46,#81,#EB,#00,#00,#01,#00,#81,#FE,#00,#00,#00,#00,
#7C,#13,#80,#7A,#19,#01,#75,#05,#2B,#72,#04,#EB,#08,#C7,#02,#00,#00,#00,#00,#EB,
#03,#49,#75,#B3,#59,#89,#72,#08,#89,#5A,#0C,#83,#C2,#20,#49,#0F,#85,#54,#FF,#FF,
#FF,#B9,#00,#00,#00,#00,#BE,#00,#00,#00,#00,#BF,#00,#00,#00,#00,#8B,#06,#83,#C6,
#04,#3D,#00,#00,#00,#F0,#7D,#04,#B0,#00,#EB,#09,#3D,#FF,#00,#00,#F0,#7E,#02,#B0,
#FF,#88,#07,#47,#49,#75,#E1,#07,#1F,#61,#9D,#CF})
poke4(ISR_ADR + 53, ISR_ADR + 272)
poke4(ISR_ADR + 63, ISR_ADR + 272)
poke4(ISR_ADR + 113, ISR_ADR + 189)
poke4(ISR_ADR + 121, ISR_ADR + 195)
poke4(ISR_ADR + 145, ISR_ADR + 173)
poke4(ISR_ADR + 155, ISR_ADR + 216)

--constant cli = allocate_proc({#C3,#00})
--constant sti = allocate_proc({#C3,#00})
--lock_memory(cli, 2)
--lock_memory(sti, 2)

atom data_buffer
atom volume_table, MIXER_BUFFER
SOUND_INIT = 0
volume_table = 0
global_volume = allocate(1)
if not global_volume then
    debug("Could Not Allocate global volume.\n")
    abort(1)
end if
lock_memory(global_volume, 1)
poke(global_volume,255)

segment = allocate(4)
if not segment then
    debug("Could Not Allocate segment.\n")
    abort(1)
end if
lock_memory(segment, 4)
save_segment = allocate(11)
if not save_segment then
    debug("Could Not Allocate save_segment.\n")
    abort(1)
end if

procedure setup_isr()
    debug("Setting Up ISR.")
    
    poke(save_segment, {#53,#0E,#5B,#89, #1D} & int_to_bytes(segment) & {#5B,#C3})
    call(save_segment) -- save code segment
    code_segment = peek(segment) + 256 * peek(segment+1)
    debug("Saved Code Segment.")

    poke(save_segment+1, #1E) 
    call(save_segment) -- save data segment
    data_segment = peek(segment) + 256 * peek(segment+1)
    debug("Saved Data Segment.")

    poke4(ISR_ADR + 5, data_segment)
    poke4(ISR_ADR + 13, BASE_IO)
    poke(ISR_ADR + 29, (IRQ > 7))   --FUNKY_IRQ
    poke4(ISR_ADR + 42, IRQ_SAMPLES)
    poke4(ISR_ADR + 47, DMA_BUFFER)
    poke4(ISR_ADR + 68, MIXER_BUFFER)
    poke4(ISR_ADR + 80, CHANNELS)
    poke4(ISR_ADR + 85, data_buffer)
    poke4(ISR_ADR + 99, MIXER_BUFFER)
    poke4(ISR_ADR + 130, global_volume)
    poke4(ISR_ADR + 140, volume_table)
    poke4(ISR_ADR + 161, IRQ_SAMPLES)
    poke4(ISR_ADR + 262, IRQ_SAMPLES)
    poke4(ISR_ADR + 267, MIXER_BUFFER)
    poke4(ISR_ADR + 272, DMA_BUFFER+IRQ_SAMPLES)

    if IRQ >= 8 then
	usual_address = get_vector(IRQ - 8 + #70) --get original interrupt vector
    else
	usual_address = get_vector(IRQ + 8) --get original interrupt vector
    end if
    
    debug("Saved Original Sound Interrupt.")
    
    if IRQ >= 8 then
	set_vector(IRQ - 8 + #70, {code_segment,ISR_ADR})   --set new interrupt vector.
    else
	set_vector(IRQ + 8, {code_segment,ISR_ADR})   --set new interrupt vector.
    end if
    debug("Set New Sound Interrupt.")
    
    enable_irq(IRQ)
    debug("IRQ Enabled.\n")
end procedure

sequence DMAS
DMAS = {#87,#83,0,#82}

global procedure close_sound()
    debug("Closing Sound... ")
    if SOUND_INIT = 0 then
	debug("Sound Already Closed.")
	return
    else
	SOUND_INIT = 0
    end if
    
    debug("\nDisable Interrupts.")
    --call(cli)       --disable interrupts

    debug("Turning Speaker Off.")
    write_dsp(#D0)      --speaker off
    write_dsp(#DA)
    
    debug("Restoring Original Sound Interrupt.")

    if IRQ >= 8 then
	set_vector(IRQ - 8 + #70, usual_address)    --restore original isr
    else
	set_vector(IRQ + 8, usual_address)    --restore original isr
    end if
    
    --disable IRQ
    debug("IRQ Disabled.")
    disable_irq(IRQ)

    debug("Enable Interrupts.")
    --call(sti)   --enable interrupts.
	
    debug("Free DMA_BUFFER.")
    free_low(DMA_BUFFER)
    debug("Free data_buffer.")
    free(data_buffer)
    debug("Free MIXER_BUFFER.\n")
    free(MIXER_BUFFER)
end procedure

function Ehex_to_i(sequence HStr)
integer i
    i = 0
    for  n = 1 to length(HStr) do
    if HStr[n] >= '0' and HStr[n] <= '9' then
	i = i * 16 + HStr[n] - '0'
    elsif HStr[n] >= 'A' and HStr[n] <= 'Z' then
	i = i * 16 + HStr[n] - 'A' + 10
    else exit
    end if
    end for
    return i
end function

function Ea_to_i(sequence NbStr)
integer i
    i = 0
    for n = 1 to length(NbStr) do
    if NbStr[n] >= '0' and NbStr[n] <= '9' then
	i = i * 10 + NbStr[n] - '0'
    else
	exit
    end if
    end for
    return i
end function

function Eupper(sequence Str)
sequence UpStr
    UpStr = ""
    for i = 1 to length(Str) do
    if Str[i] >= 'a' and Str[i] <='z' then
	UpStr = UpStr & 'A' + (Str[i] - 'a')
    else
	UpStr = UpStr & Str[i]
    end if
    end for
    return UpStr
end function

function blaster_info()
sequence data
object blaster
integer i
    data = {0,0,0}
    blaster =  getenv("BLASTER")
    if atom(blaster) then
	return -1
    end if

    blaster = Eupper(blaster)
    i = match("A",blaster)
    if not i then
	return -1
    end if
    data[1] = Ehex_to_i(blaster[i+1..i+4])
    if data[1] < #210 then
	return -1
    end if

    i = match("I",blaster)
    if not i then
	return -1
    end if
    data[2] = Ea_to_i(blaster[i+1..i+2])
    if not find(data[2],{1,2,3,5,7,8,9,10,11}) then
	return -1
    end if

    i = match("D",blaster)
    if not i then
	return -1
    end if

    data[3] = blaster[i+1] - '0'
    if not find(data[3],{0,1,3}) then
	return -1
    end if
    
    return data
end function

global function auto_detect()
object temp
    debug("Auto Detecting Sound Card.")
    temp = blaster_info()
    if atom(temp) then
	debug("Error Detecting Card.\n")
	return {0,0,0}
    else
	debug("Sound Card Detected.\n")
	return temp
    end if
end function

sequence legals
legals = {{#210,#220,#230,#240,#250,#260,#270,#280},
	    {1,2,3,5,7,8,9,10,11},{0,1,3}}

atom DSP_VERSION

global procedure init_sound(integer rate, integer channels, sequence setups)
sequence voltemp

    debug("Initializing Sound.")
    
    if SOUND_INIT = 1 then
	debug("Sound Already Initialized.")
	close_sound()
    end if
    SOUND_INIT = 0

    if length(setups) != 3  then
	debug("Bad Setup Values.\n")
	return
    end if
    for i = 1 to 3 do
	if not find(setups[i],legals[i]) then
	    debug("Illegal Setup Values.\n")
	    return
	end if
    end for

    BASE_IO = setups[1]
    IRQ = setups[2]
    DMA = setups[3]
    
    if channels > 64 then
	debug("Number of channels reduced to 64.")
	channels = 64
    elsif channels < 4 then
	debug("Number of channels increased to 4.")
	channels = 4
    end if

    CHANNELS = channels

    if rate < 8000 then
	debug("Rate increased to 8000Hz.")
	rate = 8000
    elsif rate > 44100 then
	debug("Rate lowered to 44100Hz.")
	rate = 44100
    end if

    RATE = rate

    if reset_dsp() = 0 then
	for i = 1 to 3 do
	    debug("Trying Reset Dsp Again...\n")
	    if reset_dsp() = 1 then
		exit
	    elsif i = 3 then
		return
	    end if
	end for
    end if
    
    DSP_VERSION = get_dsp_version()
    if DSP_VERSION < 2.0 then
	debug("DSP Version Is < 2.0, Too Old To Run Ecstacy.\n")
	return
    else
	debug(sprintf("DSP VERSION OK (%.2f).",DSP_VERSION))
    end if

    debug("Preparing DMA Buffer.")
    BUFFER_LEN = floor(RATE / IRQPS)
    IRQ_SAMPLES = BUFFER_LEN
    DMA_LEN = IRQ_SAMPLES * 2
    DMA_BUFFER = allocate_dma_buffer(DMA_LEN)
    if not DMA_BUFFER then
	return
    else
	debug("Clearing DMA Buffer.")
	lock_memory(DMA_BUFFER, DMA_LEN)
	mem_set(DMA_BUFFER,128,DMA_LEN)
    end if

    debug("Preparing Data Buffer.")
    data_buffer = allocate(channels * 32)
    if not data_buffer then
	free_low(DMA_BUFFER)
	debug("Not Enough Memory.\n")
	return
    else
	debug("Clearing Data Buffer.")
	lock_memory(data_buffer, 32 * channels)
	mem_set(data_buffer, 0, 32 * channels)
    end if

    MIXER_BUFFER = allocate(IRQ_SAMPLES*4)
    if not MIXER_BUFFER then
	free_low(DMA_BUFFER)
	free(data_buffer)
	debug("Not Enough Memory.\n")
	return
    else
	debug("MIXER_BUFFER OK.")
	lock_memory(MIXER_BUFFER,IRQ_SAMPLES*4)
	--poke4(MIXER_BUFFER,repeat(#F000007F,IRQ_SAMPLES))
    end if

    if volume_table = 0 then
	debug("Setting Up volume table.")
	volume_table = allocate(65536)
	debug("allocated volume table.")
	if not volume_table then
	    debug("Not Enough Memory for volume table.\n")
	    free_low(DMA_BUFFER)
	    free(data_buffer)
	    free(MIXER_BUFFER)
	    return
	end if

	for v = 0 to 255 do
	    voltemp = repeat(v,256)
	    for s = 0 to 255 do
		voltemp[s+1] *= (s-128)
	    end for
	    poke(volume_table + (v*256), floor(voltemp/255)+128)
	end for
	--for v = 0 to 255 do
	    --for s = 0 to 255 do
		--poke(volume_table + (v*256) + s,  floor(((s - 128)/255)*v)+128)
	    --end for
	--end for
	debug("Volume table calculated.")

	debug("locking volume table.")
	lock_memory(volume_table, 65536)
	debug("locked volume table.")
    else
	debug("VOLUME ALREADY SETUP.")
    end if

    setup_isr()

    debug("Enable Sound.")
    write_dsp(#D1) --Enable sound

    if DSP_VERSION < 4.0 then
	debug("Set Time Constant.")
	write_dsp(#40) --Set time constant.
	write_dsp(floor((65536 - (256000000 / rate)) / 256))
    else
	debug("Set Playback Rate.")
	write_dsp(#41) --Set time constant.
	write_dsp(floor(rate/256))
	write_dsp(remainder(rate,256))
    end if

    Eout_byte(#0A,or_bits(DMA,4))    --mask DMA
    Eout_byte(#0C,0)                 --clear byte pointer

    debug("Set DMA Mode.")
    Eout_byte(#0B,or_bits(#58,DMA))  --set mode

    debug("Set DMA Address.")
    Eout_byte(DMA*2,and_bits(DMA_BUFFER,#FF))    --set address
    Eout_byte(DMA*2,floor(and_bits(DMA_BUFFER,#FF00)/256))
    Eout_byte(DMAS[DMA+1],floor(and_bits(DMA_BUFFER,#F0000)/65536))

    debug("Set DMA Length.")
    Eout_byte(DMA*2 + 1, remainder((DMA_LEN-1),256)) --set length
    Eout_byte(DMA*2 + 1, floor((DMA_LEN-1)/256))

    Eout_byte(#0A,DMA)   --unmask dma

    debug("Disable Interrupts.")
    --call(cli)   --disable interrupts
    
    debug("Set Interrupt Frequency.")
    write_dsp(#48)      --setup interrupt frequency.
    write_dsp(remainder((IRQ_SAMPLES - 1), 256))
    write_dsp(floor((IRQ_SAMPLES - 1) / 256))

    debug("Start Playback.")
    write_dsp(#1C)  --start playback

    debug("Enable Interrupts.")
    --call(sti)       --enable interrupts

    debug("Sound Setup OK!.\n")
    debug(sprintf("BLASTER #%x, %d,%d",{BASE_IO,IRQ,DMA}))
    if setup_error then
	debug("A DSP ERROR OCCURED SOMEWHERE")
    end if
    SOUND_INIT = 1
end procedure

global procedure play_sound(sequence s, sequence dat)
atom adr, scale
    --s = {address, length, rate}
    --dat = {volume, channel, loop, alt_rate}
    if s[1] = 0 then
	debug("Sound Not Loaded.")
	return
    end if
    if SOUND_INIT = 0 then
	return
    end if
    if dat[2] < 0 or dat[2] >= CHANNELS then
	debug("Playing Sound on an Invalid Channel")
	return
    end if
    if length(dat) = 4 then
	s[3] = dat[4]
    end if
    if s[3] < 1 then
	s[3] = 1
    elsif s[3] > 88200 then
	s[3] = 88200
    end if
    if dat[1] < 0 then
	dat[1] = 0
    elsif dat[1] > 255 then
	dat[1] = 255
    end if

    adr = data_buffer + (dat[2] * 32)
    scale = floor((s[3] / RATE)*65536)
    poke4(adr, 0)   --stop current sound from playing first.
    poke4(adr + 4, s[2])
    poke4(adr + 8, s[1])
    poke4(adr + 12, 0)
    poke4(adr + 16, floor(scale/65536))
    poke4(adr + 20, remainder(scale,65536))
    poke(adr + 24, dat[1])
    poke(adr + 25, (dat[3] > 0))
    poke4(adr, s[1])
end procedure 

global procedure stop_sound(integer chan)
    if SOUND_INIT = 0 then
	return
    end if
    if chan = -1 then
	for i = 0 to CHANNELS-1 do
	    poke4(data_buffer + (i * 32), 0)
	end for
	return
    end if
    if chan < 0 or chan >= CHANNELS then
	debug("Tried to stop sound on an Invalid Channel.")
	return
    end if
    poke4(data_buffer + (chan * 32), 0)
end procedure

global function still_playing(integer chan)
    if SOUND_INIT = 0 then
	return 0
    end if
    if chan < 0 or chan >= CHANNELS then
	debug("Tried to check sound on an Invalid Channel.")
	return 0
    end if
    if peek4u(data_buffer + (chan * 32)) = 0 then
	return 0
    else
	return 1
    end if
end function

global function get_free_channel()
    for i = 0 to CHANNELS-1 do
	if not still_playing(i) then
	    return i
	end if
    end for
    return -1
end function

global procedure set_channel_volume(integer chan, integer vol)
    if SOUND_INIT = 0 then
	return
    end if
    if vol < 0 then
	vol = 0
    elsif vol > 255 then
	vol = 255
    end if
    if chan = -1 then
	for i = 0 to CHANNELS-1 do
	    poke(data_buffer + (i * 32) + 24, vol)
	end for
	return
    end if
    if chan < 0 or chan >= CHANNELS then
	debug("Tried to set volume on an Invalid Channel.")
	return
    end if
    poke(data_buffer + (chan * 32) + 24, vol)
end procedure

constant volume_constants = {#04,#22}
global procedure set_sb_volume(object vol)
    if atom(vol) then
	vol = {vol,vol}
    end if
    if length(vol) != 2 then
	debug("Sequence for set_sb_volume() must be 2 elements")
	return
    end if
    for i = 1 to 2 do
	if vol[i] > 7 then
	    vol[i] = 7
	elsif vol[i] < 0 then
	    vol[i] = 0
	end if
    end for
    for i = 1 to 2 do
	Eout_byte(BASE_IO + #4, volume_constants[i])
	Eout_byte(BASE_IO + #5, (vol[i] * 2) + (vol[i] * 32))
    end for
end procedure

global function get_sb_volume()
    return {0,0}
end function

function read_x(integer fn, integer x)
sequence temp
    temp = repeat(0,x)
    for i = 1 to x do
	temp[i] = getc(fn)
    end for
    return temp
end function

constant proc16_8 = allocate(29)
if proc16_8 = 0 then
    debug("Could not allocate 16bit-8bit proc")
    puts(1,"Could not allocate 16bit-8bit proc")
    abort(1)
end if
poke(proc16_8, {
    #60,                    --    0: pusha
    #BE,#00,#00,#00,#00,    --    1: mov esi, src (2)
    #BF,#00,#00,#00,#00,    --    6: mov edi, dest (7)
    #B9,#00,#00,#00,#00,    --    B: mov ecx, len (12)
    #66,#AD,                --   10: l1: lodsw
    #80,#C4,#80,            --   12: add ah, 128
    #88,#E0,                --   15: mov al, ah
    #AA,                    --   17: stosb
    #49,                    --   18: dec ecx
    #75,#F5,                --   19: jnz l1
    #61,                    --   1B: popa
    #C3})                   --   1C: ret

constant procs_m = allocate(36)
if procs_m = 0 then
    debug("Could not allocate Stereo to Mono proc")
    puts(1,"Could not allocate Stereo to Mono proc")
    abort(1)
end if
poke(procs_m, {
    #60,                    --    0: pusha
    #BE,#00,#00,#00,#00,    --    1: mov esi, src (2)
    #BF,#00,#00,#00,#00,    --    6: mov edi, dest (7)
    #B9,#00,#00,#00,#00,    --    B: mov ecx, len (12)
    #66,#AD,                --   10: l1: lodsw
    #88,#E3,                --   12: mov bl, ah
    #30,#E4,                --   14: xor ah, ah
    #30,#FF,                --   16: xor bh, bh
    #66,#01,#D8,            --   18: add ax, bx
    #66,#D1,#E8,            --   1B: shr ax, 1
    #AA,                    --   1E: stosb
    #49,                    --   1F: dec ecx
    #75,#EE,                --   20: jnz l1
    #61,                    --   22: popa
    #C3})                   --   23: ret

function convert_16_8(atom src, atom len)
atom dest
    debug("Converting sound 16-Bit to 8-Bit.")
    dest = allocate(len)
    if dest = 0 then
	debug("Couldn't allocate a buffer.")
	free(src)
	return 0
    end if
    poke4(proc16_8 + 2, src)
    poke4(proc16_8 + 7, dest)
    poke4(proc16_8 + 12, len)
    call(proc16_8)
    free(src)
    return dest
end function

function convert_stereo_mono(atom src, atom len)
atom dest
    debug("Converting stereo sound mono.")
    dest = allocate(len)
    if dest = 0 then
	debug("Couldn't allocate a buffer.")
	free(src)
	return 0
    end if
    poke4(procs_m + 2, src)
    poke4(procs_m + 7, dest)
    poke4(procs_m + 12, len)
    call(procs_m)
    free(src)
    return dest
end function

integer load_wave_bits, load_wave_channels
function read_wave_fmt(integer fn)
object dat, temp
    dat = bytes_to_int(read_x(fn,4))
    temp = read_x(fn,dat)
    dat = repeat(0,4)
    dat[1] = temp[1] + temp[2]*256
    dat[2] = temp[3] + temp[4]*256
    dat[3] = bytes_to_int(temp[5..8])
    dat[4] = temp[15] + temp[16]*256

    if dat[1] != 1 then
	debug("Wave file unable to be loaded (bad format)")
	return -1
    elsif dat[2] != 1 and dat[2] != 2 then
	debug("Wave file unable to be loaded (too many channels)")
	return -1
    elsif dat[4] != 8 and dat[4] != 16 then
	debug("Wave file unable to be loaded (unsupported Bit-Number)")
	return -1
    end if
    load_wave_bits = dat[4]
    load_wave_channels = dat[2]
    return dat[3]   --speed
end function

function read_wave_data(integer fn, sequence fname)
atom wh
object temp, dat

    temp = bytes_to_int(read_x(fn,4))
    dat = {allocate(temp),temp, fn}
    if dat[1] = 0 then
	close(fn)
	return -1
    end if
    wh = where(fn)
    close(fn)

    fn = Dwdos_open(fname,0)
    if fn = -1 then
	return -1
    end if

    temp = Dwdos_seek(fn,wh,0)
    temp = Dwblock_read(fn,dat[1],dat[2])
    temp = Dwdos_close(fn)
    
    fn = open(fname,"rb")
    if fn = -1 then
	free(dat[1])
	return -1
    end if
    temp = seek(fn,wh+dat[2])
    return dat    --address, length
end function

procedure skip_chunk(integer fn)
object dat, temp
    dat = bytes_to_int(read_x(fn,4))
    temp = read_x(fn,dat)
end procedure

global function load_wave(sequence fname, atom dist)
object temp
atom got_fmt, got_data
sequence wave_info
integer fn
    got_fmt = 0
    got_data = 0
    wave_info = {0,0,0}

    fn = open(fname,"rb")
    if fn = -1 then
	debug("WAV NOT LOADED!")
	return {0,0,0}
    end if
    if dist > 0 then
	if seek(fn,dist) then
	    close(fn)
	    debug("WAV NOT LOADED!")
	    return {0,0,0}
	end if
    end if

    temp = read_x(fn,4)
    if compare(temp,"RIFF") then
	close(fn)
	debug("WAV NOT LOADED!")
	return {0,0,0}
    end if
    
    temp = read_x(fn,4)
    if compare(read_x(fn,4),"WAVE") then
	close(fn)
	debug("WAV NOT LOADED!")
	return {0,0,0}
    end if

    while 1 do
	temp = read_x(fn,4)
	if find(-1,temp) then
	    close(fn)
	    debug("WAV NOT LOADED!")
	    return {0,0,0}
	end if
	if compare(temp,"fmt ") = 0 then
	    temp = read_wave_fmt(fn)
	    if temp = -1 then
		close(fn)
		if wave_info[1] then
		    free(wave_info[1])
		end if
		debug("WAV NOT LOADED!")
		return {0,0,0}
	    end if
	    wave_info[3] = temp
	    got_fmt = 1
	elsif compare(temp,"data") = 0 then
	    temp = read_wave_data(fn,fname)
	    if atom(temp) then
		return {0,0,0}
	    end if
	    wave_info[1..2] = temp[1..2]
	    fn = temp[3]
	    got_data = 1
	else
	    skip_chunk(fn)
	end if
	if got_fmt = 1 and got_data = 1 then
	    exit
	end if
    end while
    close(fn)
    
    if load_wave_bits = 16 then
	wave_info[2] = floor(wave_info[2]/2)
	wave_info[1] = convert_16_8(wave_info[1],wave_info[2])
	if wave_info[1] = 0 then
	    return {0,0,0}
	end if
    end if
    if load_wave_channels = 2 then
	wave_info[2] = floor(wave_info[2]/2)
	wave_info[1] = convert_stereo_mono(wave_info[1],wave_info[2])
	if wave_info[1] = 0 then
	    return {0,0,0}
	end if
    end if
    return wave_info
end function

global procedure store_waves(sequence names, sequence end_name)
object temp
integer in, out, upto
sequence lengths
atom wh, buffer, total_len, temp_len
    if atom(names[1]) then
	debug("Bad names sequence for store_waves().")
	return
    end if
    lengths = repeat(0,length(names))
    total_len = 0
    for i = 1 to length(names) do
	temp = dir(names[i])
	if atom(temp) then
	    debug(sprintf("File not found for store_waves(): %s.",{names[i]}))
	    return
	end if
	lengths[i] = temp[1][3]
	total_len += temp[1][3]
    end for
    
    position(1,1)
    printf(1,"Storing %d Sounds in File \"%s\".\n\n\n",{length(names),end_name})
    out = open(end_name,"wb")
    puts(out,"WPAK")
    puts(out,int_to_bytes(1))--file format version 1
    puts(out,int_to_bytes(length(names)))
    upto = 12 + (4 * length(names))
    for i = 1 to length(names) do
	puts(out,int_to_bytes(upto))
	upto += lengths[i]
    end for
    wh = where(out)
    close(out)
    out = Dwdos_open(end_name,1)
    temp = Dwdos_seek(out,wh,0)

    puts(1,"Left To Go [                                                  ]")
    temp_len = 0
    for i = 1 to length(names) do
	position(3,1)
	printf(1,"(%s)                                   ",{names[i]})
	in = Dwdos_open(names[i],0)
	buffer = allocate(lengths[i])
	temp = Dwblock_read(in,buffer,lengths[i])
	temp = Dwblock_write(out,buffer,lengths[i])
	free(buffer)
	temp = Dwdos_close(in)
	temp_len += lengths[i]
	position(4,13)
	temp = repeat(' ',50)
	temp[1..floor(50 * (temp_len / total_len))] = '.'
	puts(1,temp)
    end for
    puts(1,"\n\nDone.\n\n")
    temp = Dwdos_close(out)
end procedure

global function load_stored_wave(sequence name, integer num)
integer fn
object temp
atom version
    if num < 1 then
	return {0,0,0}
    end if
    fn = open(name,"rb")
    if fn = -1 then
	return {0,0,0}
    end if
    temp = read_x(fn,4)
    if compare(temp,"WPAK") != 0 then
	close(fn)
	return {0,0,0}
    end if
    version = bytes_to_int(read_x(fn,4))
    if version = 1 then
	temp = bytes_to_int(read_x(fn,4))
	if num > temp then
	    return {0,0,0}
	end if
	temp = seek(fn,num*4+8)
	temp = bytes_to_int(read_x(fn,4))
	close(fn)
	return load_wave(name,temp)
    else
	return {0,0,0}
    end if
end function

global procedure free_waves(sequence waves)
    if atom(waves[1]) then
	if waves[1] then
	    free(waves[1])
	end if
    else
	for i = 1 to length(waves) do
	    if waves[i][1] then
		free(waves[i][1])
	    end if
	end for
    end if
end procedure

--END OF ECSTACY SOUND SYSTEM.
